﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using Infragistics.Windows.DataPresenter;
using Infragistics.Windows;
using Infragistics.Windows.Controls;
using System.Collections.ObjectModel;

namespace DataCarouselFun
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {        

        public MainWindow()
        {                      
            InitializeComponent();            
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            CarouselViewPanel viewPanel = (CarouselViewPanel)Utilities.GetDescendantFromType(_dataCarousel, typeof(CarouselViewPanel), true);
            viewPanel.ExecutingCommand += new EventHandler<Infragistics.Windows.Controls.Events.ExecutingCommandEventArgs>(viewPanel_ExecutingCommand);
        }

        void viewPanel_ExecutingCommand(object sender, Infragistics.Windows.Controls.Events.ExecutingCommandEventArgs e)
        {
            CarouselViewPanel viewPanel = (CarouselViewPanel)sender;
            ObjectDataProvider provider = this.Resources["GroupPanelsData"] as ObjectDataProvider;
            ObservableCollection<DataCarouselFun.GroupPanelData> datasource = provider.Data as ObservableCollection<DataCarouselFun.GroupPanelData>;

            if (e.Command == XamCarouselPanelCommands.NavigateToNextItem)
            {
                if (viewPanel.FirstVisibleItemIndex + 1 >= datasource.Count - 2)
                    e.Cancel = true;
            }
            if (e.Command == XamCarouselPanelCommands.NavigateToPreviousItem)
            {
                if (viewPanel.FirstVisibleItemIndex == 0)
                    e.Cancel = true;
            }
            if (e.Command == XamCarouselPanelCommands.NavigateToNextPage)
            {
                _dataCarousel.BringRecordIntoView(_dataCarousel.Records[datasource.Count - 1]);
                e.Cancel = true;
            }
            if (e.Command == XamCarouselPanelCommands.NavigateToPreviousPage)
            {
                _dataCarousel.BringRecordIntoView(_dataCarousel.Records[0]);
                e.Cancel = true;
            }
        }

        private void _dataCarousel_RecordExpanding(object sender, Infragistics.Windows.DataPresenter.Events.RecordExpandingEventArgs e)
        {
            MessageBox.Show("Record Expanding");
        }
    }
}
